"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.entries");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

require("core-js/modules/web.timers");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("regenerator-runtime/runtime");

var _package = require("../../../package.json");

var _Shuo = _interopRequireDefault(require("./shuoCore/Shuo"));

var _DBClient = _interopRequireDefault(require("./dbCore/DBClient"));

var _storeUtil = require("./reduxCore/storeUtil");

var _storeActions = require("./reduxCore/actions/storeActions");

var _conditionType = require("./shuoCore/conditionType");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var QINJS_Version = {
  system: 'QINJS_Version'
};
var REACTOR_CONTENT = {
  system: 'REACTOR_CONTENT'
};
var SHUO_RULE = {
  system: 'SHUO_RULE'
};

var Reactor = /*#__PURE__*/function () {
  function Reactor(props) {
    _classCallCheck(this, Reactor);

    _defineProperty(this, "_name", void 0);

    _defineProperty(this, "_debugging", void 0);

    _defineProperty(this, "_shuo", void 0);

    _defineProperty(this, "_store", void 0);

    _defineProperty(this, "_dbCore", void 0);

    _defineProperty(this, "_timerId", void 0);

    _defineProperty(this, "_storeData", void 0);

    _defineProperty(this, "_eventTimeoutQueue", void 0);

    _defineProperty(this, "_performanceTicker", void 0);

    this._shuo = new _Shuo["default"]();
    this._name = props.name;
    this._eventTimeoutQueue = {};
    this._debugging = props.debugging || false;
    this._performanceTicker = typeof performance !== 'undefined' ? performance : eval("require('perf_hooks').performance;");
  }

  _createClass(Reactor, [{
    key: "init",
    value: function () {
      var _init = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;

                this._initShuo();

                this._initDB();

                this._initRedux(this._debugging);

                _context.next = 6;
                return this._isSameVersion();

              case 6:
                if (_context.sent) {
                  _context.next = 10;
                  break;
                }

                if (this._debugging) {
                  console.log('Core version is not the same, init new reactor');
                }

                _context.next = 10;
                return this._initReactorChain();

              case 10:
                _context.next = 12;
                return this._hasContent();

              case 12:
                if (_context.sent) {
                  _context.next = 16;
                  break;
                }

                if (this._debugging) {
                  console.log('No reactor content found, init reactor content');
                }

                _context.next = 16;
                return this._initReactorContent();

              case 16:
                _context.next = 21;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](0);
                console.error(_context.t0);

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 18]]);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: "syncStoreToDBCore",
    value: function syncStoreToDBCore() {
      var _this = this;

      this._store.subscribe(function () {
        _this._storeData = _this._store.getState();
      });
    }
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(delta, tick) {
        var _this2 = this;

        var terrainInfo, rules;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                // console.log(delta);
                terrainInfo = this._storeData.terrainInfo;
                _context4.next = 3;
                return this.getRules();

              case 3:
                rules = _context4.sent;
                [terrainInfo].forEach( /*#__PURE__*/function () {
                  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(statusInfo) {
                    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, data, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, rule, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, trigger, dispatchData, rate;

                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _iteratorNormalCompletion = true;
                            _didIteratorError = false;
                            _iteratorError = undefined;
                            _context2.prev = 3;
                            _iterator = statusInfo.dataSet[Symbol.iterator]();

                          case 5:
                            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                              _context2.next = 73;
                              break;
                            }

                            data = _step.value;
                            _iteratorNormalCompletion2 = true;
                            _didIteratorError2 = false;
                            _iteratorError2 = undefined;
                            _context2.prev = 10;
                            _iterator2 = rules[Symbol.iterator]();

                          case 12:
                            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                              _context2.next = 56;
                              break;
                            }

                            rule = _step2.value;

                            if (!(data.type === rule.attribute.type)) {
                              _context2.next = 53;
                              break;
                            }

                            _iteratorNormalCompletion3 = true;
                            _didIteratorError3 = false;
                            _iteratorError3 = undefined;
                            _context2.prev = 18;
                            _iterator3 = rule.eventTriggers[Symbol.iterator]();

                          case 20:
                            if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                              _context2.next = 39;
                              break;
                            }

                            trigger = _step3.value;

                            if (!Reactor.checkConditions(data, trigger.conditions)) {
                              _context2.next = 36;
                              break;
                            }

                            dispatchData = {
                              type: trigger.name,
                              playload: {
                                triggerBy: data
                              }
                            };
                            rate = Math.random();

                            if (!(rate > trigger.rate)) {
                              _context2.next = 36;
                              break;
                            }

                            if (trigger.timeOut && !_this2._eventTimeoutQueue[trigger.name]) {
                              _this2._eventTimeoutQueue[trigger.name] = 0;
                            }

                            if (!(_this2._eventTimeoutQueue[trigger.name] !== undefined && tick > _this2._eventTimeoutQueue[trigger.name])) {
                              _context2.next = 33;
                              break;
                            }

                            _this2._eventTimeoutQueue[trigger.name] = tick + trigger.timeOut;
                            _context2.next = 31;
                            return _this2._store.dispatch(dispatchData);

                          case 31:
                            _context2.next = 36;
                            break;

                          case 33:
                            if (trigger.timeOut) {
                              _context2.next = 36;
                              break;
                            }

                            _context2.next = 36;
                            return _this2._store.dispatch(dispatchData);

                          case 36:
                            _iteratorNormalCompletion3 = true;
                            _context2.next = 20;
                            break;

                          case 39:
                            _context2.next = 45;
                            break;

                          case 41:
                            _context2.prev = 41;
                            _context2.t0 = _context2["catch"](18);
                            _didIteratorError3 = true;
                            _iteratorError3 = _context2.t0;

                          case 45:
                            _context2.prev = 45;
                            _context2.prev = 46;

                            if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
                              _iterator3["return"]();
                            }

                          case 48:
                            _context2.prev = 48;

                            if (!_didIteratorError3) {
                              _context2.next = 51;
                              break;
                            }

                            throw _iteratorError3;

                          case 51:
                            return _context2.finish(48);

                          case 52:
                            return _context2.finish(45);

                          case 53:
                            _iteratorNormalCompletion2 = true;
                            _context2.next = 12;
                            break;

                          case 56:
                            _context2.next = 62;
                            break;

                          case 58:
                            _context2.prev = 58;
                            _context2.t1 = _context2["catch"](10);
                            _didIteratorError2 = true;
                            _iteratorError2 = _context2.t1;

                          case 62:
                            _context2.prev = 62;
                            _context2.prev = 63;

                            if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
                              _iterator2["return"]();
                            }

                          case 65:
                            _context2.prev = 65;

                            if (!_didIteratorError2) {
                              _context2.next = 68;
                              break;
                            }

                            throw _iteratorError2;

                          case 68:
                            return _context2.finish(65);

                          case 69:
                            return _context2.finish(62);

                          case 70:
                            _iteratorNormalCompletion = true;
                            _context2.next = 5;
                            break;

                          case 73:
                            _context2.next = 79;
                            break;

                          case 75:
                            _context2.prev = 75;
                            _context2.t2 = _context2["catch"](3);
                            _didIteratorError = true;
                            _iteratorError = _context2.t2;

                          case 79:
                            _context2.prev = 79;
                            _context2.prev = 80;

                            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                              _iterator["return"]();
                            }

                          case 82:
                            _context2.prev = 82;

                            if (!_didIteratorError) {
                              _context2.next = 85;
                              break;
                            }

                            throw _iteratorError;

                          case 85:
                            return _context2.finish(82);

                          case 86:
                            return _context2.finish(79);

                          case 87:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, null, [[3, 75, 79, 87], [10, 58, 62, 70], [18, 41, 45, 53], [46,, 48, 52], [63,, 65, 69], [80,, 82, 86]]);
                  }));

                  return function (_x3) {
                    return _ref.apply(this, arguments);
                  };
                }());
                this._timerId = setTimeout( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                  return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          _context3.next = 2;
                          return _this2.update(_this2._performanceTicker.now() - tick, _this2._performanceTicker.now());

                        case 2:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3);
                })), 50);

              case 6:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function update(_x, _x2) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "start",
    value: function () {
      var _start = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var _this3 = this;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.prev = 0;
                _context6.next = 3;
                return this.getData();

              case 3:
                this._storeData = _context6.sent;
                this.syncStoreToDBCore();
                this._timerId = setTimeout( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
                  return regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          _context5.next = 2;
                          return _this3.update(0, 0);

                        case 2:
                        case "end":
                          return _context5.stop();
                      }
                    }
                  }, _callee5);
                })), 50);
                _context6.next = 8;
                return this._store.dispatch((0, _storeActions.storeConnectReactor)(this._storeData));

              case 8:
                _context6.next = 13;
                break;

              case 10:
                _context6.prev = 10;
                _context6.t0 = _context6["catch"](0);
                console.error(_context6.t0);

              case 13:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this, [[0, 10]]);
      }));

      function start() {
        return _start.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: "stop",
    value: function stop() {
      try {
        clearTimeout(this._timerId);
      } catch (e) {
        console.error(e);
      }
    }
  }, {
    key: "_initRedux",
    value: function _initRedux(debugging) {
      this._store = (0, _storeUtil.initStore)(debugging);

      this._store.dispatch((0, _storeActions.storeInit)());
    }
  }, {
    key: "getData",
    value: function () {
      var _getData = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var data;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this._dbCore.queryOne(REACTOR_CONTENT);

              case 2:
                data = _context7.sent;
                return _context7.abrupt("return", data.value);

              case 4:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getData() {
        return _getData.apply(this, arguments);
      }

      return getData;
    }()
  }, {
    key: "getRules",
    value: function () {
      var _getRules = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
        var rules;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this._dbCore.queryOne(SHUO_RULE);

              case 2:
                rules = _context8.sent;
                return _context8.abrupt("return", rules.value);

              case 4:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getRules() {
        return _getRules.apply(this, arguments);
      }

      return getRules;
    }()
  }, {
    key: "_initReactorChain",
    value: function () {
      var _initReactorChain2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this._dbCore.update(QINJS_Version, _objectSpread({}, QINJS_Version, {
                  value: 0
                }));

              case 2:
                _context9.next = 4;
                return this._dbCore.update(SHUO_RULE, _objectSpread({}, SHUO_RULE, {
                  value: this._shuo.getRule()
                }));

              case 4:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function _initReactorChain() {
        return _initReactorChain2.apply(this, arguments);
      }

      return _initReactorChain;
    }()
  }, {
    key: "_initReactorContent",
    value: function () {
      var _initReactorContent2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this._dbCore.update(REACTOR_CONTENT, _objectSpread({}, REACTOR_CONTENT, {
                  value: this._shuo.getContent()
                }));

              case 2:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function _initReactorContent() {
        return _initReactorContent2.apply(this, arguments);
      }

      return _initReactorContent;
    }()
  }, {
    key: "_initShuo",
    value: function _initShuo() {
      this._shuo.init();
    }
  }, {
    key: "_initDB",
    value: function _initDB() {
      this._dbCore = new _DBClient["default"]({
        name: "QINJS_".concat(this._name, "_DB")
      });
    }
  }, {
    key: "_isSameVersion",
    value: function () {
      var _isSameVersion2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
        var versionDoc;
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.prev = 0;
                _context11.next = 3;
                return this._dbCore.queryOne(QINJS_Version);

              case 3:
                versionDoc = _context11.sent;

                if (!versionDoc) {
                  _context11.next = 6;
                  break;
                }

                return _context11.abrupt("return", versionDoc.value === _package.version);

              case 6:
                return _context11.abrupt("return", false);

              case 9:
                _context11.prev = 9;
                _context11.t0 = _context11["catch"](0);
                console.error(_context11.t0);
                throw _context11.t0;

              case 13:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this, [[0, 9]]);
      }));

      function _isSameVersion() {
        return _isSameVersion2.apply(this, arguments);
      }

      return _isSameVersion;
    }()
  }, {
    key: "_hasContent",
    value: function () {
      var _hasContent2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
        var hasContent;
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.prev = 0;
                _context12.next = 3;
                return this._dbCore.query(REACTOR_CONTENT);

              case 3:
                hasContent = _context12.sent;
                return _context12.abrupt("return", !!hasContent.length);

              case 7:
                _context12.prev = 7;
                _context12.t0 = _context12["catch"](0);
                console.error(_context12.t0);
                throw _context12.t0;

              case 11:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this, [[0, 7]]);
      }));

      function _hasContent() {
        return _hasContent2.apply(this, arguments);
      }

      return _hasContent;
    }()
  }, {
    key: "loadExtra",
    value: function loadExtra(extra) {
      this._shuo.loadExtra(extra);
    }
  }], [{
    key: "checkConditions",
    value: function checkConditions(status, conditions) {
      for (var condition in conditions) {
        switch (condition) {
          case _conditionType.CONDITION.MORE_THAN:
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
              for (var _iterator4 = conditions[_conditionType.CONDITION.MORE_THAN][Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                var moreThanProps = _step4.value;
                var matched = 0;

                for (var prop in moreThanProps) {
                  if (moreThanProps[prop] < status[prop]) {
                    matched++;
                  }

                  if (matched === Object.entries(moreThanProps).length) {
                    return true;
                  }
                }
              }
            } catch (err) {
              _didIteratorError4 = true;
              _iteratorError4 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion4 && _iterator4["return"] != null) {
                  _iterator4["return"]();
                }
              } finally {
                if (_didIteratorError4) {
                  throw _iteratorError4;
                }
              }
            }

            break;

          case _conditionType.CONDITION.EQUAL:
            var _iteratorNormalCompletion5 = true;
            var _didIteratorError5 = false;
            var _iteratorError5 = undefined;

            try {
              for (var _iterator5 = conditions[_conditionType.CONDITION.EQUAL][Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                var equalProps = _step5.value;
                var _matched = 0;

                for (var _prop in equalProps) {
                  if (equalProps[_prop] === status[_prop]) {
                    _matched++;
                  }

                  if (_matched === Object.entries(equalProps).length) {
                    return true;
                  }
                }
              }
            } catch (err) {
              _didIteratorError5 = true;
              _iteratorError5 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion5 && _iterator5["return"] != null) {
                  _iterator5["return"]();
                }
              } finally {
                if (_didIteratorError5) {
                  throw _iteratorError5;
                }
              }
            }

            break;

          case _conditionType.CONDITION.LESS_THAN:
            var _iteratorNormalCompletion6 = true;
            var _didIteratorError6 = false;
            var _iteratorError6 = undefined;

            try {
              for (var _iterator6 = conditions[_conditionType.CONDITION.LESS_THAN][Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                var lessThanProps = _step6.value;
                var _matched2 = 0;

                for (var _prop2 in lessThanProps) {
                  if (lessThanProps[_prop2] > status[_prop2]) {
                    _matched2++;
                  }

                  if (_matched2 === Object.entries(lessThanProps).length) {
                    return true;
                  }
                }
              }
            } catch (err) {
              _didIteratorError6 = true;
              _iteratorError6 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion6 && _iterator6["return"] != null) {
                  _iterator6["return"]();
                }
              } finally {
                if (_didIteratorError6) {
                  throw _iteratorError6;
                }
              }
            }

            break;

          case _conditionType.CONDITION.EXCLUDE:
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = conditions[_conditionType.CONDITION.EXCLUDE][Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var excludeProps = _step7.value;
                var _matched3 = 0;

                for (var _prop3 in excludeProps) {
                  if (status[_prop3]) {
                    _matched3++;
                  }
                }

                if (_matched3 === 0) {
                  return true;
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7["return"] != null) {
                  _iterator7["return"]();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }

            break;

          case _conditionType.CONDITION.INCLUDE:
            var _iteratorNormalCompletion8 = true;
            var _didIteratorError8 = false;
            var _iteratorError8 = undefined;

            try {
              for (var _iterator8 = conditions[_conditionType.CONDITION.INCLUDE][Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                var includeProps = _step8.value;
                var _matched4 = 0;

                for (var _prop4 in includeProps) {
                  if (status[_prop4]) {
                    _matched4++;
                  }

                  if (_matched4 === Object.entries(includeProps).length) {
                    return true;
                  }
                }
              }
            } catch (err) {
              _didIteratorError8 = true;
              _iteratorError8 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion8 && _iterator8["return"] != null) {
                  _iterator8["return"]();
                }
              } finally {
                if (_didIteratorError8) {
                  throw _iteratorError8;
                }
              }
            }

            break;

          default:
            break;
        }
      }

      return false;
    }
  }]);

  return Reactor;
}();

var _default = Reactor;
exports["default"] = _default;